#!/usr/local/bin/perl

#
# JOYFUL NOTE : joyful.cgi - 2014/01/05
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# ݒt@CF
require "./init.cgi";
my %cf = init();

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('eʃI[o[') if ($cgi->truncated);
my %in = parse_form($cgi);

# 
if ($in{mode} eq 'find') { find_data(); }
if ($in{mode} eq 'note') { note_page(); }
if ($in{mode} eq 'past' && $cf{pastkey}) { past_log(); }
if ($in{mode} eq 'album') { album(); }
bbs_list();

#-----------------------------------------------------------
#  L\
#-----------------------------------------------------------
sub bbs_list {
	# ԐMtH[
	$in{res}  =~ s/\D//g;
	$in{read} =~ s/\D//g;
	res_form($in{res}) if ($in{res} || $in{read});

	# gsbN\
	bbs_topic() if ($in{bbs} == 1);

	# y[W`
	my $pg = $in{pg} || 0;

	# LWJ
	my ($i,@log,%res,%nam,%sub,%dat,%com,%url,%col,%ext,%imw,%imh);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		++$i if (!$reno);
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_thread});

		# eL
		if (!$reno) {
			push(@log,$no);
		# XL
		} else {
			$res{$reno} .= "$no,";
		}
		# N
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{auto_link});

		# nbV
		$nam{$no} = $name;
		$sub{$no} = $sub;
		$dat{$no} = $date;
		$com{$no} = $com;
		$col{$no} = $col;
		$url{$no} = $url;
		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext{$no} = "hide";
			} else {
				$ext{$no} = $ext;
				$imw{$no} = $w;
				$imh{$no} = $h;
			}
		}
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = make_pgbtn($i,$pg,'',$cf{max_thread});

	# NbL[擾
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# JE^
	my $counter = bbs_count() if ($cf{counter});

	# ev[gǍ
	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ߋO
	$tmpl =~ s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);

	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	my $resloop = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$head =~ s/<!-- captcha -->.+<!-- captcha -->//s;
	}

	# u
	for ($head,$foot) {
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!homepage!/$cf{homepage}/g;
		s/!page_btn!/$page_btn/g;
		s/!name!/$cook[0]/;
		s/!email!/$cook[1]/;
		s/!url!/$cook[2]/;
		s/!str_crypt!/$str_crypt/g;
		s/!color!/$color/g;
		s/!sub!//g;
		s/!reno!//g;
		s/!counter!/$counter/g;
	}

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# L\
	foreach (@log) {
		# X
		my $res;
		foreach my $r ( split(/,/, $res{$_}) ) {
			# Yt
			$com{$r} = qq|<span style="color:$col[$col{$r}]">$com{$r}</span>|;
			if (defined($ext{$r})) {
				$com{$r} = att_file($r,$com{$r},$ext{$r},$imw{$r},$imh{$r});
			}
			my $tmp = $resloop;
			$tmp =~ s/!sub!/$sub{$r}/g;
			$tmp =~ s/!name!/$nam{$r}/g;
			$tmp =~ s/!url!/$url{$r}/g;
			$tmp =~ s/!date!/$dat{$r}/g;
			$tmp =~ s/!num!/$r/g;
			$tmp =~ s/!comment!/$com{$r}/g;
			$res .= $tmp;
		}
		# Yt
		$com{$_} = qq|<span style="color:$col[$col{$_}]">$com{$_}</span>|;
		if (defined($ext{$_})) {
			$com{$_} = att_file($_,$com{$_},$ext{$_},$imw{$_},$imh{$_});
		}
		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub{$_}/g;
		$tmp =~ s/!name!/$nam{$_}/g;
		$tmp =~ s/!url!/$url{$_}/g;
		$tmp =~ s/!date!/$dat{$_}/g;
		$tmp =~ s/!num!/$_/g;
		$tmp =~ s/!comment!/$com{$_}/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s|<!-- res -->|<div class="ta-r">$res</div>|g if ($res);
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  ԐMtH[
#-----------------------------------------------------------
sub res_form {
	my $resnum = $in{res} ? $in{res} : $in{read};
#	my $bbs = $in{bbs} == 1 ? 1 : 0;

	my ($flg,$resub,@res,%nam,%sub,%dat,%com,%url,%ext,%chk,%col,%imw,%imh);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		if ($resnum == $no) {
			$flg = 1;

			# ^Cg
			if ($sub =~ /^Re:/) {
				$resub = $sub;
			} else {
				$resub = "Re: $sub";
			}

		} elsif ($resnum == $reno) {
			push(@res,$no);
		} else {
			next;
		}
		# N
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{auto_link});

		$nam{$no} = $name;
		$sub{$no} = $sub;
		$dat{$no} = $date;
		$com{$no} = $com;
		$col{$no} = $col;
		$url{$no} = $url;
		$chk{$no} = $chk;
		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext{$no} = "hide";
			} else {
				$ext{$no} = $ext;
				$imw{$no} = $w;
				$imh{$no} = $h;
			}
		}
	}
	close(IN);

	if (!$flg) { error("sȕԐMvł"); }

	# NbL[擾
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# ev[gǍ
	my $file = $in{read} ? 'topic2.html' : 'bbs.html';
	open(IN,"$cf{tmpldir}/$file") or error("open err: $file");
	my $tmpl = join('', <IN>);
	close(IN);

	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	my $resloop = join('', <IN>);
	close(IN);

	# ߋO
	$tmpl =~ s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);

	# ev[g
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$head =~ s/<!-- captcha -->.+<!-- captcha -->//s;
	}

	# u
	for ($head, $foot) {
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!homepage!/$cf{homepage}/g;
		s/!name!/$cook[0]/;
		s/!email!/$cook[1]/;
		s/!url!/$cook[2]/;
		s/!str_crypt!/$str_crypt/g;
		s/!color!/$color/g;
		s/!sub!/$resub/g;
		s/!reno!/$resnum/g;
		s/!counter!//g;
		s/!page_btn!//g;
	}

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# X
	my $res;
	foreach my $r (@res) {
		# Yt
		$com{$r} = qq|<span style="color:$col[$col{$r}]">$com{$r}</span>|;
		if (defined($ext{$r})) {
			$com{$r} = att_file($r,$com{$r},$ext{$r},$imw{$r},$imh{$r});
		}
		# u
		my $tmp = $resloop;
		$tmp =~ s/!sub!/$sub{$r}/g;
		$tmp =~ s/!name!/$nam{$r}/g;
		$tmp =~ s/!date!/$dat{$r}/g;
		$tmp =~ s/!url!/$url{$r}/g;
		$tmp =~ s/!num!/$r/g;
		$tmp =~ s|!comment!|$com{$r}|g;
		$res .= $tmp;
	}

	# Yt
	$com{$resnum} = qq|<span style="color:$col[$col{$resnum}]">$com{$resnum}</span>|;
	if (defined($ext{$resnum})) {
		$com{$resnum} = att_file($resnum,$com{$resnum},$ext{$resnum},$imw{$resnum},$imh{$resnum});
	}
	# u
	$loop =~ s/!sub!/$sub{$resnum}/g;
	$loop =~ s/!name!/$nam{$resnum}/g;
	$loop =~ s/!date!/$dat{$resnum}/g;
	$loop =~ s/!url!/$url{$resnum}/g;
	$loop =~ s/!num!/$resnum/g;
	$loop =~ s/!comment!/$com{$resnum}/g;
	$loop =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$loop =~ s|<!-- res -->|<div class="ta-r">$res</div>|g if ($res);
	print $loop;

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  [h
#-----------------------------------------------------------
sub find_data {
	# /\`
	$in{cond} =~ s/\D//g;
	my $bbs = $in{bbs} == 1 ? 1 : 0;

	# v_E
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# s
	my ($hit,@log) = search($cf{logfile}) if ($in{word} ne '');

	# ev[g
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# u
	for ($head, $foot) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/<!-- op_cond -->/$op_cond/;
		s/!word!/$in{word}/;
		s/!bbs!/$bbs/g;
	}

	# wb_
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [v
	foreach my $log (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/,$log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com  = auto_link($com) if ($cf{auto_link});
		$url  = qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>| if ($url);
		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext = "hide";
			}
			$com = att_file($no,$com,$ext,$w,$h);
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!comment!/$com/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my ($file,$list,$stat) = @_;

	# R[hϊ
	if ($cf{conv_code} == 1) {
		require './lib/Jcode.pm';
		$in{word} = Jcode->new($in{word})->sjis;
	}

	# L[[hz
	$in{word} =~ s/@/ /g;
	my @wd = split(/\s+/,$in{word});

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# 
	my ($i,@log);
	open(IN,"$file") or error("open err: $file");
	my $top = <IN> if (!$stat);
	while (<IN>) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if ($in{cond} == 0) { last; }
			} else {
				if ($in{cond} == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		$i++;
		if ($list > 0) {
			next if ($i < $in{pg} + 1);
			next if ($i > $in{pg} + $list);
		}

		push(@log,$_);
	}
	close(IN);

	# 
	return ($i,@log);
}

#-----------------------------------------------------------
#  ӎ\
#-----------------------------------------------------------
sub note_page {
	# gqi\pj
	my $ext = ext_file();

	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!file!/$ext/g;
	$tmpl =~ s/!maxdata!/$cf{maxdata}oCg/g;
	$tmpl =~ s/!max_w!/$cf{max_img_w}/g;
	$tmpl =~ s/!max_h!/$cf{max_img_h}/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  Ao@\
#-----------------------------------------------------------
sub album {
	# y[W/\`
	my $pg = $in{pg} || 0;
	my $bbs = $in{bbs} == 1 ? 1 : 0;

	# 摜TCYĒ`
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# ev[gF
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# f[^ǂݍ
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ex,$w,$h,$chk) = split(/<>/);
		next if ($cf{img_check} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + 10);

		# 摜f[^W
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# Jz{^
	my $page_btn = make_pgbtn($i,$pg,'&mode=album',$cf{max_albums});

	# u
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!page_btn!/$page_btn/g;
		s/!bbs!/$bbs/g;
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!image!/image($no,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  ߋO
#-----------------------------------------------------------
sub past_log {
	# ߋOԍ
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# v_E^O쐬
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected>$i\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i\n|;
		}
	}

	# y[W
	my $pg = $in{pg} || 0;

	# 
	my ($hit,$page_btn,$hit,@log,%res);

	# ΏۃO`
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# [h
	if ($in{find} && $in{word} ne '') {
		# 
		($hit,@log) = search($file,$in{list},'past');

		# 
		$page_btn = "ʁF<b>$hit</b> &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,$in{list},'find');

	# Oꗗ
	} else {
		my $pg_max = $cf{max_thread} * 2;

		# ߋOI[v
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);
			++$i if ($reno eq '');
			next if ($i < $pg + 1);
			next if ($i > $pg + $pg_max);

			if ($reno) {
				$res{$reno} .= "$no<>$reno<>$date<>$nam<>$eml<>$sub<>$com<>$url<>$col\0";
				next;
			}
			push(@log,$_);
		}
		close(IN);

		# Jz{^쐬
		$page_btn = pgbtn_old($i,$in{pno},$pg,$pg_max);
	}

	# v_E쐬ij
	my %op = make_op();

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	my $restmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	if ($in{change}) { $in{word} = ''; }

	my @col = split(/\s+/,$cf{colors});

	# u
	for ($head, $foot) {
		s/!past_num!/$in{pno}/g;
		s/!bbs_url!//g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/<!-- op_pno -->/$op_pno/g;
		s/<!-- op_(\w+) -->/$op{$1}/g;
		s/!word!/$in{word}/g;
		s/!page_btn!/$page_btn/g;
	}

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@log) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$com = auto_link($com) if ($cf{auto_link});
		$url = qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>| if ($url);

		# X
		my $res;
		foreach my $log ( split(/\0/,$res{$no}) ) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$col) = split(/<>/, $log);
			$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
			$com = auto_link($com) if ($cf{auto_link});
			$url = qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>| if ($url);

			my $tmp = $restmpl;
			$tmp =~ s/!sub!/$sub/g;
			$tmp =~ s/!name!/$nam/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!url!/$url/g;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
			$res .= $tmp;
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!comment!/$com/g;
		$tmp =~ s/<!-- res -->/<blockquote>$res<\/blockquote>/g if ($res);

		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  gsbNX
#-----------------------------------------------------------
sub bbs_topic {
	# NbL[擾
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# JE^
	my $counter = bbs_count() if ($cf{counter});

	# y[W
	my $pg = $in{pg} || 0;

	# f[^F
	my ($i,@log,%res,%last);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while(<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		if (!$reno) { $i++; }
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_topics});

		if ($reno) { $res{$reno}++; $last{$reno} = "$date<br>$name"; }
		else { $last{$no} = "$date<br>$name"; }

		push(@log,$_) if (!$reno);
	}
	close(IN);

	# Jz{^쐬
	my $pg_btn = make_pgbtn($i,$pg,'&bbs=1',$cf{max_topics});

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/topic.html") or error("open err: topic.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha -->.+<!-- captcha -->//s;
	}

	# u
	$tmpl =~ s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!page_btn!/$pg_btn/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!sub!//g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/\?mode=(album|find)/?mode=$1&bbs=1/g;

	# 
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# eLWJ
	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		if ($res{$no} eq '') { $res{$no} = 0; }

		my $tmp = $loop;
		$tmp =~ s/!topi-num!/$no/g;
		$tmp =~ s|!topi-ttl!|<a href="$cf{bbs_cgi}?read=$no">$sub</a>|g;
		$tmp =~ s/!topi-nam!/$name/g;
		$tmp =~ s/!topi-res!/$res{$no}/g;
		$tmp =~ s/!topi-last!/$last{$no}/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  URLGR[h
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  Jz{^쐬 [ ߋO ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$list,$stat) = @_;

	# y[WJz`
	my $next = $pg + $list;
	my $back = $pg - $list;

	my $link;
	if ($stat eq 'find') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&pno=$pno&find=1&word=$wd&list=$list";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&pno=$pno";
	}

	# y[WJz{^쐬
	my $pg_btn;
	if ($back >= 0 || $next < $i) {
		$pg_btn .= "Page: ";

		my ($x, $y) = (1, 0);
		while ($i > 0) {
			if ($pg == $y) {
				$pg_btn .= qq(| <b>$x</b> );
			} else {
				$pg_btn .= qq(| <a href="$link&pg=$y">$x</a> );
			}
			$x++;
			$y += $list;
			$i -= $list;
		}
		$pg_btn .= "|";
	}
	return $pg_btn;
}

#-----------------------------------------------------------
#  v_E쐬 [  ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected>$cond{$_}\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected>$i\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  JE^
#-----------------------------------------------------------
sub bbs_count {
	# IP擾
	my $addr = $ENV{REMOTE_ADDR};

	# {̂݃JEgAbv
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# JEgt@Cǂ݂
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	# IP`FbNƃOj`FbN
	my ($cnt,$ip) = split(/:/, $count);
	if ($addr eq $ip || $cnt eq "") { $cntup = 0; }

	# JEgAbv
	if ($cntup) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//, $cnt);

	# GIFJE^\
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif" alt="$cnts[$_]">|;
		}

	# eLXgJE^\
	} else {
		$counter = qq|<span style="color:$cf{cntcol};font-family:Verdana,Helvetica,Arial">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">Joyful Note</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  Jz{^쐬
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# y[WJz`
	my $next = $pg + $max;
	my $back = $pg - $max;

	# y[WJz{^쐬
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	
	# ʂԂ
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/,$cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  YtN
#-----------------------------------------------------------
sub att_file {
	my ($no,$com,$ex,$w,$h) = @_;

	# J
	if ($ex eq 'hide') {
		$com .= qq|<p>[Yt]: Fؑ҂</p>|;

	# 摜̂Ƃ
	} elsif ($ex =~ /(jpg|png|gif)$/) {

		my $op;
		if (-f "$cf{imgdir}/$no-s$ex") {
			$op = qq|src="$cf{imgurl}/$no-s$ex"|;
		} else {
			($w,$h) = resize($w,$h);
			$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
		}

		# 摜̓Rg̉
		if ($cf{image_position} == 1) {
			$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;
		# 摜̓Rg̍i荞݁j
		} else {
			$com = qq|<a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0" align="left"></a>$com<br clear="all">|;
		}

	## ̃ubNǉ ##
	# JX^f[^̂Ƃ
	} elsif ($ex =~ /(alp|wbs|icp|pos|anm|han|dnc|bbs|fsp|fms|fps|hrp|hms|ims|ips|bms|mps|man)$/) {

		my $op;
		if (-f "$cf{imgdir}/$no-s.png") {
			$op = qq|src="$cf{imgurl}/$no-s.png"|;
		}

		# ΉQ[̎擾
		my $usable = availability("$cf{imgdir}/$no$ex");

		# TlCƂ
		if ($op) {
			my $tbl = qq|<tr><td class="oldlog"><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></td></tr><tr align=center><td class="oldlog">$usable</td></tr>|;
			
			# 摜̓Rg̉
			if ($cf{image_position} == 1) {
				$com .= qq|<p><table>$tbl</table></p>|;
			# 摜̓Rg̍i荞݁j
			} else {
				$com = qq|<table align="left">$tbl</table>$com<br clear="all">|;
			}
		# TlCȂƂ
		} else {
			my $size = -s "$cf{imgdir}/$no$ex" || 0;
			$com .= qq|<p>[<a href="$cf{imgurl}/$no$ex" target="_blank">Yt</a>]: $size bytes<br>$usable</p>|;
		}
	# 摜ȊÔƂ
	} else {
		my $size = -s "$cf{imgdir}/$no$ex" || 0;
		$com .= qq|<p>[<a href="$cf{imgurl}/$no$ex" target="_blank">Yt</a>]: $size bytes</p>|;
	}

	return $com;
}

#-----------------------------------------------------------
#  舵t@C
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});

		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;

	return $ext;
}

#-----------------------------------------------------------
#  摜\
#-----------------------------------------------------------
sub image {
	my ($no,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{imgdir}/$no-s$ex") {
		$image = qq|<img src="$cf{imgurl}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{imgurl}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a href="$cf{imgurl}/$no$ex" target="_blank">$image</a>\n|;
}

#-----------------------------------------------------------
#  JX^t@Co[W擾
#-----------------------------------------------------------
## Tu[`ǉ ##
sub availability {
	my $cus = shift;

	my $buf;
	open(SRC,"$cus");
	binmode(SRC);
	read(SRC, $buf, 12);
	close(SRC);

	my $av_str;
	my $fver = unpack("L", substr($buf, 8, 4));
	if ($cus =~ /dnc$/) {
		if ($fver < 7) {
			$av_str = "sȃo[Wł";
		} elsif ($fver == 7) {
			$av_str = "ԃMAȍ~";
		} elsif ($fver <= 0x0A) {
			$av_str = "J}`JmWȍ~";
		} elsif ($fver == 0x0B) {
			$av_str = "ԃfXehm`kI";
		} else {
			$av_str = "ΉQ[sł";
		}
	} elsif ($cus =~ /man$/) {
		if ($fver < 6) {
			$av_str = "sȃo[Wł";
		} elsif ($fver == 6) {
			$av_str = "ԃMAȍ~";
		} elsif ($fver == 7) {
			$av_str = "J}`JmWȍ~";
		} else {
			$av_str = "ΉQ[sł";
		}
	} elsif ($cus =~ /han$/) {
		if ($fver < 6) {
			$av_str = "sȃo[Wł";
		} elsif ($fver <= 7) {
			$av_str = "ԃMAȍ~";
		} elsif ($fver == 8) {
			$av_str = "J}`JmWȍ~";
		} elsif ($fver == 9) {
			$av_str = "ԃfXehm`kI";
		} else {
			$av_str = "ΉQ[sł";
		}
	} elsif ($cus =~ /anm$/) {
		if ($fver < 6) {
			$av_str = "sȃo[Wł";
		} elsif ($fver <= 7) {
			$av_str = "ԃMAȍ~";
		} elsif ($fver == 8) {
			$av_str = "J}`JmWȍ~";
		} else {
			$av_str = "ΉQ[sł";
		}
	} elsif ($cus =~ /pos$/) {
		if ($fver < 6) {
			$av_str = "sȃo[Wł";
		} elsif ($fver == 6) {
			$av_str = "ԃMAȍ~";
		} else {
			$av_str = "ΉQ[sł";
		}
	} elsif ($cus =~ /(icp|ims|ips|bms|mps)$/) {
		if ($fver < 0x0A) {
			$av_str = "sȃo[Wł";
		} elsif ($fver == 0x0A) {
			$av_str = "J}`JmWȍ~";
		} elsif ($fver == 0x0B) {
			$av_str = "ԃfXehm`kI";
		} else {
			$av_str = "ΉQ[sł";
		}
	} else {
		if ($fver < 1) {
			$av_str = "sȃo[Wł";
		} elsif ($fver <= 5) {
			$av_str = "ނވȍ~";
		} elsif ($fver <= 7) {
			$av_str = "ԃMAȍ~";
		} elsif ($fver <= 0x0A) {
			$av_str = "J}`JmWȍ~";
		} elsif ($fver == 0x0B) {
			$av_str = "ԃfXehm`kI";
		} else {
			$av_str = "ΉQ[sł";
		}
	}

	return $av_str;

#
# Ql(낾up00454.zipVERMEMO.TXT])
#
# FMS
# FPS
# HMS
# BBS ICP
# WBS IMS
# FSP IPS
# HRP BMS
# ALP MPS POS ANM HAN MAN DNC
# 2,3  x   x   x   x   x   x   HCŤ1(``1.00)
#   4  x   x   x   x   x   x   HCŤ2?(`2.00?)
#   5  x   x   x   x   x   x   HCŤ2/i(`2.01`)
#   6  x    6   6   6  6?  x   LǦ1(`3.00)
#   7  x    6   7   7   6   7  LǦ2/i(`3.01`)
#   A   A   6   8   8   7   A  NNKǨ/i(`4.00`)
#   B   B   6   8   9   7   B  LDFi(`5.00`)

# ̐(16i)$fverɓĂ
}

