#!/usr/local/bin/perl

#
# UP-LOADER : upload.cgi - 2013/02/10
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
## TlCöגǉ ##
use IO::Uncompress::Inflate qw(inflate $InflateError);
use lib "./lib";
use CGI::Simple;

# ݒeF
require "./init.cgi";
my %cf = init();

# f[^
$CGI::Simple::DISABLE_UPLOADS = 0;
$CGI::Simple::POST_MAX = $cf{maxdata};
my $cgi = new CGI::Simple;
error('eʃI[o[') if ($cgi->cgi_error);
my %in = parse_form($cgi);

# 
if ($in{get}) { download(); }
if ($in{del}) { del_data(); }
if ($in{mode} eq 'regist') { regist(); }
list_data();

#-----------------------------------------------------------
#  ꗗXg
#-----------------------------------------------------------
sub list_data {
	# y[W`
	my $pg = $in{pg} || 0;

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# L[[hz
	$in{word} =~ s/@/ /g;
	my @wd = split(/\s+/, $in{word});

	# Ot@CǍ
	my ($i,@data,%ct);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while(<IN>) {
		my ($no,$date,$mime,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

		# 
		if ($in{mode} eq 'find' && $in{word} ne '') {
			my $flg;
			foreach my $wd (@wd) {
				if ("$ex $com" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
					$flg++;
				} else {
					$flg = 0;
					last;
				}
			}
			next if (!$flg);

		# 
		} else {
			$i++;
			next if ($i < $pg + 1);
			next if ($i > $pg + $cf{pg_max});
		}

		$ct{$no} = 0;
		push(@data,$_);
	}
	close(IN);

	# Jz{^쐬
	my $pg_btn = make_pgbtn($i,$pg);

	# JEgt@CǍ
	open(IN,"$cf{cntfile}") or error("open err: $cf{cntfile}");
	while(<IN>) {
		chomp;
		my ($no,$cnt) = split(/:/);

		if (defined($ct{$no})) { $ct{$no} = $cnt; }
	}
	close(IN);

	# ev[gǍ
	my $file = $in{mode} eq 'find' ? 'find.html' : 'upload.html';
	open(IN,"$cf{tmpldir}/$file") or error("open err: $file");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : error("ev[gs");

	# őeʁi\pj
	my $maxdata = int($cf{maxdata}/1024) . 'KB';

	# gqi\pj
	my $ext = ext_file();

	# u
	foreach ( $head, $foot ) {
		s/!homepage!/$cf{homepage}/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!maxdata!/$maxdata/g;
		s/!maxcom!/$cf{max_com}/g;
		s/!ext!/$ext/g;
		s/!log_max!/$cf{log_max}/g;
		s/!page_btn!/$pg_btn/g;
		s|!ico_lock!|<img src="$cf{ico_lock}" alt="bN" class="icon">|g;
		s/!word!/$in{word}/g;
	}

	# wb_[WJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [vWJ
	foreach (@data) {
		my ($no,$date,$mime,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

		# lock or free
		my ($icon,$fnam);
		if ($lock) {
			$icon = $cf{ico_lock};
			$fnam = qq|<a href="$cf{upload_cgi}?get=$no"target="popup" onclick="popup('$cf{upload_cgi}?get=$no')">$no.$ex</a>|;
		} else {
			$icon = $cf{ico_down};
			$fnam = qq|<a href="$cf{upload_cgi}?get=$no" target="_blank">$no.$ex</a>|;
		}

		## ǉ ##
		# TlC̏
		my $thumb;
		if (-f "$cf{upldir}/$rand-s.png") {
			$thumb = qq|<img src="$cf{upldir}/$rand-s.png" width="$cf{max_img_w}" height="$cf{max_img_h}">|;
			# JX^t@C̏ꍇ
			if ($ex =~ /(alp|wbs|icp|pos|anm|han|dnc|bbs|fsp|fms|fps|hrp|hms|ims|ips|bms|mps|man)$/i) {
				my $suru_ver = availability("$cf{upldir}/$rand.$ex");
				$thumb .= "<br>$suru_ver";
			}
		} else {
			$thumb = "<br>";
		}

		# mimeŒ̂̓Jbg
		if (length($mime) > $cf{mime_max}) {
			$mime = substr($mime, 0, $cf{mime_max}) . '..';
		}

		# u
		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!size!/$size/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s|!icon!|<img src="$icon" alt="" class="icon">|g;
		$tmp =~ s/!fname!/$fnam/g;
		$tmp =~ s/!thumb!/$thumb/g;
		$tmp =~ s/!comment!/$com/g;
		$tmp =~ s/!count!/$ct{$no}/g;
		$tmp =~ s/!mime!/$mime/g;
		$tmp =~ s/!upload_cgi!/$cf{upload_cgi}/g;
		$tmp =~ s|!ico_del!|<img src="$cf{ico_del}" alt="폜" class="icon">|g;
		print $tmp;
	}
	# f[^tbV
	@data = ();

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  f[^o^
#-----------------------------------------------------------
sub regist {
	# IP/zXg`FbN
	my ($host,$addr) = get_host();
	chk_host($host,$addr);

	# Abv[ht@C擾
	my $upfile = $cgi->param('upfile');

	# ̓`FbN
	my $err;
	if (!$upfile) { $err .= "t@C͂ł<br>\n"; }
	if (!$in{comment}) { $err .= "Rg͂ł<br>\n"; }
	elsif (length($in{comment}) > $cf{max_com}) { $err .= "Rg$cf{max_com}ȓł<br>\n"; }
	error($err) if ($err);

	# MIME^Cv擾
	my $mime = $cgi->upload_info($upfile,'mime');

	# gq擾
	my $ext = $upfile =~ /\.(\w+)$/ ? $1 : error("gqsł");
	$ext =~ tr/A-Z/a-z/;

	# t@C`FbN
	check_upl($mime,$ext);

	# mimeGXP[v
	$mime =~ s/[<>&"']//g;

	# 
	srand;
	my $rand = make_rand();

	# 폜L[/Ï؃L[Í
	my $delkey = encrypt($in{delkey}) if ($in{delkey});
	my $pwdkey = encrypt($in{pwdkey}) if ($in{pwdkey});

	# t擾
	my $date = get_date();

	# OI[v
	my ($i,@log,%del);
	open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		$i++;
		my ($no,$date,$mime,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

		if ($i <= $cf{log_max} - 1) {
			push(@log,$_);
		} else {
			$del{$no}++;
			unlink("$cf{upldir}/$rand.$ex");
			## TlC̏ǉ ##
			unlink("$cf{upldir}/$rand-s.png") if (-f "$cf{upldir}/$rand-s.png");
		}
	}

	# ̔
	my ($no) = (split(/<>/, $log[0]))[0];
	$no = sprintf("%05d", $no+1);

	# Abv[h
	my $size = upload($upfile,"$rand.$ext");

	# OXV
	unshift(@log,"$no<>$date<>$mime<>$ext<>$rand<>$in{comment}<>$delkey<>$pwdkey<>$size<>$host<>\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# JEgt@Cɒǉ
	my @log;
	open(DAT,"+< $cf{cntfile}") or error("write err: $cf{cntfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($no,$cnt) = split(/:/);
		next if (defined($del{$no}));

		push(@log,$_);
	}
	unshift(@log,"$no:0\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# bZ[W
	message("Abv[h܂");
}

#-----------------------------------------------------------
#  Abv[h
#-----------------------------------------------------------
sub upload {
	my ($upfile,$upname) = @_;

	# Abvt@C`
	$upname = "$cf{upldir}/$upname";

	my $buf;
	my $fh = $cgi->upload($upfile);
	if ($fh eq '') { error($cgi->cgi_error); }
	open(UP,"+> $upname") or error("up err: $upname");
	binmode(UP);
	print UP $buf while read( $fh, $buf, 4096 );
	close(UP);

	# p[~bV666
	chmod(0666,$upname);

	## ǉ ##
	# JX^f[^t@C̎̓TlC쐬
	if ($upfile =~ /\.(alp|wbs|icp|pos|anm|han|dnc|bbs|fsp|fms|fps|hrp|hms|ims|ips|bms|mps|man)$/i) {
		my $thumb = $upname;
		substr($thumb, -4, 4) = "-s.png";
		get_cus_thumb($upname, $thumb);
	}

	# eʎ擾
	my $size = -s $upname;
	if ($size >= 1024) {
		$size = int($size/1024) . 'KB';
	} else {
		$size .= 'B';
	}
	return $size;
}

#-----------------------------------------------------------
#  _E[h
#-----------------------------------------------------------
sub download {
	# `FbN
	if ($in{get} !~ /^\d+$/) { error("sȒlł"); }
	if ($in{pwdkey} && $in{key} eq '') { error("Ï؃L[͂ł"); }

	# Ot@CǍ
	my ($file,$pwflg,$ctype);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while(<IN>) {
		my ($no,$date,$mime,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

		# Yf[^
		if ($in{get} == $no) {
			$file  = "$rand.$ex";
			$pwflg = $lock;
			$ctype = $mime;
			last;
		}
	}
	close(IN);

	# YȂ
	if (!$file) { error("Ỹt@C͂܂"); }

	# Ï؃L[ݒ̂Ƃ
	if ($pwflg) {

		# Ï͎ؓ
		if ($in{pwdkey}) {
			if (decrypt($in{key},$pwflg) != 1) {
				save_log('err');
				error("F؂ł܂");
			}

		# ʕ\̂Ƃ
		} else {
			pop_form();
		}
	}

	# JEgAbvXV
	my @data;
	open(DAT,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($no,$cnt) = split(/:/);

		if ($in{get} == $no) {
			chomp($cnt);
			$cnt++;
			$_ = "$no:$cnt\n";
		}
		push(@data,$_);
	}
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# OL^
	save_log('dl');

	# 摜̂Ƃ̓Nʕ\L
	if ($ctype =~ /^image/) {
		img_page($file);

	# 摜ȊO̓_CNg
	} else {
		if ($ENV{PERLXS} eq "PerlIS") {
			print "HTTP/1.0 302 Temporary Redirection\r\n";
			print "Content-type: text/html\n";
		}
		print "Location: $cf{uplurl}/$file\n\n";
		exit;
	}
}

#-----------------------------------------------------------
#  f[^폜
#-----------------------------------------------------------
sub del_data {
	# 폜s
	if ($in{key} ne "" && $in{delkey} == 1) {

		my ($file,$crypt,@data);
		open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while(<DAT>) {
			my ($no,$date,$fnam,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

			if ($in{del} == $no) {
				$file = "$rand.$ex";
				$crypt = $del;
				next;
			}
			push(@data,$_);
		}
		# 폜L[Ȃ
		if (!$crypt) {
			close(DAT);
			error("폜L[ݒł");
		}
		# ƍ
		if (decrypt($in{key}, $crypt) != 1) {
			close(DAT);
			error("F؂ł܂");
		}
		# XV
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# Yt폜
		unlink("$cf{upldir}/$file");
		## TlCLƂ̏ǉ ##
		my $thumb = $file;
		$thumb =~ s/\.\w{3}$/-s\.png/;
		unlink("$cf{upldir}/$thumb") if (-f "$cf{upldir}/$thumb");

		# JEgt@C폜
		my ($file,$crypt,@data);
		open(DAT,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
		eval "flock(DAT, 2);";
		while(<DAT>) {
			my ($no,$cnt) = split(/:/);
			next if ($in{del} == $no);
			push(@data,$_);
		}
		# XV
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 
		message("폜܂");

	# ̓tH[
	} else {
		delform();
	}
}

#-----------------------------------------------------------
#  t擾
#-----------------------------------------------------------
sub get_date {
	my ($min,$hour,$day,$mon,$year) = (localtime(time))[1..5];

	sprintf("%04d/%02d/%02d-%02d:%02d", $year+1900,$mon+1,$day,$hour,$min);
}

#-----------------------------------------------------------
#  bZ[W
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	open(IN,"$cf{tmpldir}/message.html") or error("open err: message.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!upload_cgi!/$cf{upload_cgi}/g;
	$tmpl =~ s/!message!/$msg/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">UPLOADER</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  cryptÍ
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	# salt쐬
	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];

	# Í
	crypt($in,$salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  cryptƍ
#-----------------------------------------------------------
sub decrypt {
	my ($in,$dec) = @_;

	# salt擾
	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);

	# ƍ
	if (crypt($in,$salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  t@C`FbN
#-----------------------------------------------------------
sub check_upl {
	my ($mime,$ext) = @_;

	## ̍ڕύX ##
	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq 'gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpeg$/i and $ext =~ /^jpe?g$/) { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq 'pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq 'zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq 'doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq 'docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq 'xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq 'xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq 'ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq 'pptx') { $flg++; }
	}
	# ǉ
	if (!$flg and $cf{ok_alp}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'alp') { $flg++; }
	}
	if (!$flg and $cf{ok_wbs}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'wbs') { $flg++; }
	}
	if (!$flg and $cf{ok_icp}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'icp') { $flg++; }
	}
	if (!$flg and $cf{ok_pos}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'pos') { $flg++; }
	}
	if (!$flg and $cf{ok_anm}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'anm') { $flg++; }
	}
	if (!$flg and $cf{ok_han}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'han') { $flg++; }
	}
	if (!$flg and $cf{ok_dnc}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'dnc') { $flg++; }
	}
	if (!$flg and $cf{ok_bbs}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'bbs') { $flg++; }
	}
	if (!$flg and $cf{ok_fsp}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'fsp') { $flg++; }
	}
	if (!$flg and $cf{ok_fms}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'fms') { $flg++; }
	}
	if (!$flg and $cf{ok_fps}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'fps') { $flg++; }
	}
	if (!$flg and $cf{ok_hrp}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'hrp') { $flg++; }
	}
	if (!$flg and $cf{ok_hms}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'hms') { $flg++; }
	}
	if (!$flg and $cf{ok_ims}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'ims') { $flg++; }
	}
	if (!$flg and $cf{ok_ips}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'ips') { $flg++; }
	}
	if (!$flg and $cf{ok_bms}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'bms') { $flg++; }
	}
	if (!$flg and $cf{ok_mps}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'mps') { $flg++; }
	}
	if (!$flg and $cf{ok_man}) {
		if ($mime =~ /^application\/octet-stream$/i and $ext eq 'man') { $flg++; }
	}

	if (!$flg) { error('̃t@C͎舵ł܂'); }
}

#-----------------------------------------------------------
#  JX^t@C̃TlCo
#-----------------------------------------------------------
## Tu[`ǉ ##
sub get_cus_thumb {
	my ($cus, $thumb) = @_;

	# JX^t@CJ
	my $buf;
	open(SRC,"$cus");
	binmode(SRC);

	# wb_̓ǂݍ݂ƍҖtB[h̃XLbv
	read(SRC, $buf, 29);
	my @header = unpack("LlL3l2C", $buf);
	seek(SRC, $header[5] * 32, 1);

	# tOĂƂ
	if ($header[7]) {
		# kf[^obt@փRs[
		read(SRC, $buf, 4);
		my $l_zd = unpack("l", $buf);
		read(SRC, $buf, $l_zd);

		# TlC̏o
		inflate(\$buf => $thumb, BinModeOut => 1);

		# 摜p[~bVύX
		chmod(0666,$thumb);
	}

	# JX^t@C
	close(SRC);
}

#-----------------------------------------------------------
#  JX^t@Co[W擾
#-----------------------------------------------------------
## Tu[`ǉ ##
sub availability {
	my $cus = shift;

	my $buf;
	open(SRC,"$cus");
	binmode(SRC);
	read(SRC, $buf, 12);
	close(SRC);

	my $av_str;
	my $fver = unpack("L", substr($buf, 8, 4));
	if ($cus =~ /dnc$/) {
		if ($fver == 7) {
			$av_str = "ver.3";
		} elsif ($fver == 0x0A) {
			$av_str = "ver.4";
		} elsif ($fver == 0x0B) {
			$av_str = "ver.5";
		} else {
			$av_str = "unknown";
		}
	} elsif ($cus =~ /man$/) {
		if ($fver == 6) {
			$av_str = "ver.3";
		} elsif ($fver == 7) {
			$av_str = "ver.4";
		} else {
			$av_str = "unknown";
		}
	} elsif ($cus =~ /han$/) {
		if ($fver == 6 || $fver == 7) {
			$av_str = "ver.3";
		} elsif ($fver == 8) {
			$av_str = "ver.4";
		} elsif ($fver == 9) {
			$av_str = "ver.5";
		} else {
			$av_str = "unknown";
		}
	} elsif ($cus =~ /anm$/) {
		if ($fver == 6 || $fver == 7) {
			$av_str = "ver.3";
		} elsif ($fver == 8) {
			$av_str = "ver.4";
		} else {
			$av_str = "unknown";
		}
	} elsif ($cus =~ /pos$/) {
		if ($fver == 6) {
			$av_str = "ver.3";
		} else {
			$av_str = "unknown";
		}
	} elsif ($cus =~ /(icp|ims|ips|bms|mps)$/) {
		if ($fver == 0x0A) {
			$av_str = "ver.4";
		} elsif ($fver == 0x0B) {
			$av_str = "ver.5";
		} else {
			$av_str = "unknown";
		}
	} else {
		if ($fver == 2 || $fver == 3) {
			$av_str = "ver.1";
		} elsif ($fver == 4 || $fver == 5) {
			$av_str = "ver.2";
		} elsif ($fver == 6 || $fver == 7) {
			$av_str = "ver.3";
		} elsif ($fver == 0x0A) {
			$av_str = "ver.4";
		} elsif ($fver == 0x0B) {
			$av_str = "ver.5";
		} else {
			$av_str = "unknown";
		}
	}

	return $av_str;

#
# Ql(낾up00454.zipVERMEMO.TXT])
#
# FMS
# FPS
# HMS
# BBS ICP
# WBS IMS
# FSP IPS
# HRP BMS
# ALP MPS POS ANM HAN MAN DNC
# 2,3  x   x   x   x   x   x   HCŤ1(``1.00)
#   4  x   x   x   x   x   x   HCŤ2?(`2.00?)
#   5  x   x   x   x   x   x   HCŤ2/i(`2.01`)
#   6  x    6   6   6  6?  x   LǦ1(`3.00)
#   7  x    6   7   7   6   7  LǦ2/i(`3.01`)
#   A   A   6   8   8   7   A  NNKǨ/i(`4.00`)
#   B   B   6   8   9   7   B  LDFi(`5.00`)

# ̐(16i)$fverɓĂ
}

#-----------------------------------------------------------
#  |bvAbvF̓tH[
#-----------------------------------------------------------
sub pop_form {
	open(IN,"$cf{tmpldir}/popup.html") or error("open err: popup.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!upload_cgi!/$cf{upload_cgi}/g;
	$tmpl =~ s/!num!/$in{get}/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  t@C폜tH[
#-----------------------------------------------------------
sub delform {
	# t@Cԃ`FbN
	if ($in{del} !~ /^\d+$/) { error('sȗvł'); }

	# f[^o
	my ($fname,$comm,$upday,$dele);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while(<IN>) {
		my ($no,$date,$mime,$ex,$rand,$com,$del,$lock,$size,$host) = split(/<>/);

		# Yf[^
		if ($in{del} == $no) {
			$fname = "$no.$ex";
			$comm  = $com;
			$upday = $date;
			$dele  = $del;
			last;
		}
	}
	close(IN);

	# G[
	if ($fname eq '') { error('wt@C͂܂'); }
	elsif ($dele eq '') { error('폜L[ݒ̂ߍ폜ł܂'); }

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/delete.html") or error("open err: delete.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!upload_cgi!/$cf{upload_cgi}/g;
	$tmpl =~ s/!num!/$in{del}/g;
	$tmpl =~ s/!fname!/$fname/g;
	$tmpl =~ s/!date!/$upday/g;
	$tmpl =~ s/!comment!/$comm/g;

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  摜Ny[W
#-----------------------------------------------------------
sub img_page {
	my $file = shift;
	my $ex = $file =~ /\.(\w+)$/ ? $1 : "";

	open(IN,"$cf{tmpldir}/image.html") or error("open err: image.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!link!|$cf{uplurl}/$file|g;
	$tmpl =~ s/!fname!/$in{get}.$ex/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  Jz{^쐬
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$next,$back) = @_;

	# 
	my $param = $in{mode} eq 'find' ? '&mode=find' : '';

	# y[WJz`
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# y[WJz{^쐬
	my $pg_btn;
	if ($back >= 0) {
		$pg_btn .= qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$back$param">&lt;</a></span>!;
	}
	if ($back >= 0 || $next < $i) {
		my ($x,$y,$z) = (1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$pg_btn .= qq!<span class="pg-on">$x</span>!;
			} else {
				$pg_btn .= qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$y$param">$x</a></span>!;
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};
		}
	}
	if ($next < $i) {
		$pg_btn .= qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$next$param">&gt;</a></span>!;
	}

	# ʂԂ
	if ($pg_btn) {
		return qq|<div class="pg-btn">$pg_btn</div>|;
	} else {
		return;
	}
}

#-----------------------------------------------------------
#  IP/zXg擾
#-----------------------------------------------------------
sub get_host {
	# IP/zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	# ϊ
	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2) or $addr;
	}
	return ($host,$addr);
}

#-----------------------------------------------------------
#  ANZX
#-----------------------------------------------------------
sub chk_host {
	my ($host,$addr) = @_;

	# IP`FbN
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg++; last; }
	}
	if ($flg) { error("ANZXĂ܂");	}

	# zXg`FbN
	if ($host ne $addr) {
		my $flg;
		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;
			if ($host =~ /$_$/i) { $flg++; last; }
		}
		if ($flg) { error("ANZXĂ܂"); }
	}
}

#-----------------------------------------------------------
#  舵t@C
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});

		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;

	return $ext;
}

#-----------------------------------------------------------
#  Oۑ
#-----------------------------------------------------------
sub save_log {
	my ($job) = @_;

	# zXg擾
	my ($host,$addr) = get_host();

	# t擾
	my $date = get_date();

	my ($i,@log);
	open(DAT,"+< $cf{dlfile}") or error("write err: $cf{dlfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		$i++;
		push(@log,$_);

		last if ($i >= $cf{dllog_max} - 1);
	}
	unshift(@log,"$job<>$in{get}<>$date<>$host<>\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);
}

